package Utils;

import okhttp3.*;

import java.io.IOException;

public class JiraTicketCreator {

    private static final String JIRA_URL = "https://arsamrajput60-1750165581004.atlassian.net/rest/api/3/issue";
    private static final String EMAIL = "arsamrajput60@gmail.com";
    private static final String API_TOKEN = "ATATT3xFfGF0xXhZtpGOqsm2xls0SCXidNjsgTHTzSdz2CXvqzBWmlHY8Q5b8-PoTVrnGP1yliLqiEMCMKumIv4tnTPWrHAZ_6OExSiia0mE6ybkgGhin2BNWlzHDTRGdxKfvG8YOX-N8v3W6ucOkq1-11sgfO4BHc38ahjik_3AsfBp7VmWqsY=4768D45A";
    private static final String AUTH = Credentials.basic(EMAIL, API_TOKEN);

    public static void createTicket(String summary, String errorLog) {
        OkHttpClient client = new OkHttpClient();

        String json = "{\n" +
                "  \"fields\": {\n" +
                "    \"project\": {\"key\": \"POC\"},\n" +
                "    \"summary\": \"" + summary + "\",\n" +
                "    \"description\": {\n" +
                "      \"type\": \"doc\",\n" +
                "      \"version\": 1,\n" +
                "      \"content\": [\n" +
                "        {\n" +
                "          \"type\": \"paragraph\",\n" +
                "          \"content\": [\n" +
                "            {\"type\": \"text\", \"text\": \"❗ Error Log: \"}\n" +
                "          ]\n" +
                "        },\n" +
                "        {\n" +
                "          \"type\": \"codeBlock\",\n" +
                "          \"attrs\": {\"language\": \"text\"},\n" +
                "          \"content\": [\n" +
                "            {\"type\": \"text\", \"text\": \"" + errorLog.replace("\"", "'").replace("\n", "\\n") + "\"}\n" +
                "          ]\n" +
                "        },\n" +
                "        {\n" +
                "          \"type\": \"paragraph\",\n" +
                "          \"content\": [\n" +
                "            {\"type\": \"text\", \"text\": \"💡 AI Suggestion: Check if the XPath locator is valid, the element exists on the page, and try using waits or alternative selectors if needed.\"}\n" +
                "          ]\n" +
                "        }\n" +
                "      ]\n" +
                "    },\n" +
                "    \"issuetype\": {\"name\": \"Task\"}\n" +
                "  }\n" +
                "}";

        RequestBody body = RequestBody.create(json, MediaType.get("application/json"));

        Request request = new Request.Builder()
                .url(JIRA_URL)
                .header("Authorization", AUTH)
                .header("Content-Type", "application/json")
                .post(body)
                .build();

        try (Response response = client.newCall(request).execute()) {
            int code = response.code();
            String responseBody = response.body() != null ? response.body().string() : "No body";

            System.out.println("JIRA ticket creation response code: " + code);
            System.out.println("JIRA response body: " + responseBody);

            if (code == 201) {
                System.out.println("Ticket created successfully.");
            } else {
                System.out.println("Ticket creation failed. Check your project key, issue type, or permissions.");
            }
        } catch (IOException e) {
            e.printStackTrace();
            System.out.println("Exception occurred during JIRA API call.");
        }
    }

    public static void main(String[] args) {
        String summary = "Automation Failure: Could not find element";
        String errorLog = "14:02:14.977 [main] ERROR - Error: Could not find search field with locator: //span[@title='NonExistentElement']";
        createTicket(summary, errorLog);
    }
}
